// DOM
var header = document.querySelector(".header");
var h1 = document.querySelector("h1");
var normalMeta = document.querySelector(".normal_meta");
var itaccountMeta = document.querySelector(".itaccount_meta");
var content = document.querySelector(".content");
var footer = document.querySelector(".footer");
var editorDom = document.querySelector(".aditor");
var rewardDom = document.querySelector(".reward");
var title = document.querySelector("title");
var paragraphWidth = window.innerWidth - 2 * 16;
var themeStyle = document.querySelector("#themeColor");

// 数据
var newsInfo = {};
var itAccountId = 0;
var newsId = 0;
var hasIframe = false;
var hasVideo = false;
var hasTable = false;
var hasPreCode = false;
var lastUserId = 0;

// 配置
var config = {};
var isIOS = false;
var isAndroid = false;
var nativeSupportLazyLoad = "loading" in document.createElement("img");
var supportLazyLoad = false;
var lazyLoadFinished = false;
var newsInfoLoaded = false;
var times = 0;
var isShareMode = false;
var isReviewMode = false;
var needAutoLoadImage = true;
var needAutoLoadGif = false;
var fontSize = null;
var isItPreviewMode = false;
setFontSize(localStorage.getItem("fontSize"));

// 定时器，页面释放时清理掉
var setNewsInfoTimer = 0;
var refreshUserInfoTimer = 0;
var resizeTimer = 0;
var setFollowStateTimer = 0;

rm.ready(function () {
  document.documentElement.classList.remove("night");
  lastUserId = getUserId() || 0;
  isIOS = rm.getEnv().platform === "iOS";
  isAndroid = rm.getEnv().platform === "Android";
  var systemInfo = rm.getSystemInfoSync().systemInfo || {};
  if (systemInfo.isReviewMode) {
    document.body.classList.add("review-mode");
    isReviewMode = true;
  }
  if (isIOS) {
    if (systemInfo.systemFontWeight) {
      document.body.classList.add("font-" + systemInfo.systemFontWeight);
    }
  }
  document.body.classList.add(rm.getEnv().platform.toLowerCase());
  /// 接收文章数据
  rm.onReceiveMessage("setNewsInfo", function (data, callback) {
    console.log(data);
    var newConfig = data.config || {};
    if ((newConfig.userId || 0) !== lastUserId) {
      refreshUserInfoTimer = setTimeout(function () {
        rm.getUserInfo(function (res) {
          lastUserId = getUserId() || 0;
          setNewsInfo(data, callback);
        });
      }, 220);
    } else {
      setNewsInfo(data, callback);
    }
    function setNewsInfo(data, callback) {
      if (data.newsInfo.draftId > 0) {
        isItPreviewMode = true;
        loadItAccountPreviewInfo(data, callback);
      } else {
        isItPreviewMode = false;
        var newData = data;
        if (newConfig.apiVer === 2) {
          // 新旧接口数据转换
          const info = data.newsInfo.data;
          const itAccount = info.itAccount ? {
            id: info.itAccount.id,
            accountname:  info.itAccount.accountName,
            accountid:  info.itAccount.accountId,
            avatarurl:  info.itAccount.avatarUrl,
            userid:  info.itAccount.userId,
            usernick:  info.itAccount.userNick,
            isinternalaccount:  info.itAccount.isInternalAccount,
          } : null;
          newData = {
            success: true,
            newsid: info.id,
            url: info.shareUrl,
            newssource: info.sourceName,
            newsauthor: info.author,
            image:info.images[0],
            imagelist: info.images,
            newstags: info.tags,
            newsflag: info.flag,
            itaccount: itAccount,
            reward: !!getSwitchByPosition(info.flag, 7) ? "1" : "0",
            detail: info.content,
            postdate: info.postDate,
            hitcount: info.hitCount,
            btheme: getSwitchByPosition(info.flag, 6),
            forbidcomment: getSwitchByPosition(info.flag, 5),
            commentcount: info.commentCount,
            z: info.editor,
            ui: (!!itAccount && itAccount.userid > 0 ? itAccount.userid : info.tougaoUserIds[0]) || 0,
          };
          Object.assign(newData, info);
          data.newsInfo = newData;
        }
        processPassedInNewsInfo(data, callback);
      }
    }
  });

  // 页面释放
  rm.onReceiveMessage("onRelease", function (data, callback) {
    clearTimeout(setNewsInfoTimer);
    clearTimeout(refreshUserInfoTimer);
    clearTimeout(resizeTimer);
    clearTimeout(setFollowStateTimer);
    const titleMark = document.querySelector(".title .comment-quote-mark");
    if (titleMark) {
      titleMark.remove();
    }
    lazyLoadFinished = false;
    newsInfoLoaded = false;
    if (isShareMode) {
      isShareMode = false;
      document.body.classList.remove("share-mode");
    }
    window.scrollTo(0, 0);
    forEachNode(content, "video", function (video) {
      video.pause();
      video.src = "";
      video.load();
      video.remove();
    });
    forEachNode(content, "iframe", function (iframe) {
      iframe.src = "about:blank";
      iframe.remove();
    });
    content.innerHTML = "";
    h1.innerText = "";
    normalMeta.style.display = "none";
    itaccountMeta.style.display = "none";
    document.body.classList.add("hide");
    document.querySelector(".follow_btn").classList.remove("inited");
    title.innerText = "文章详情页";
    callback({
      success: true,
    });
  });

  function loadItAccountPreviewInfo(data, callback) {
    var apiUrl = "https://mp.ithome.com/api/news/itaccount/getdraft";
    switch (data.from) {
      case "pending":
        apiUrl = "https://mp.ithome.com/api/news/itaccount/getnews";
        break;
      case "review":
        apiUrl = "https://mp.ithome.com/api/news/itaccount/mgetnews";
        break;
    }
    var reqUrl = Api(apiUrl, {
      id: data.newsInfo.draftId,
      userhash: getUserHash(),
    });
    rm.login(function (res) {
      if (res.success) {
        rm.request({ url: reqUrl }, function (draftIndo) {
          if (draftIndo.data.success) {
            var draft = draftIndo.data.content.draft;
            data.newsInfo = {
              success: true,
              newsid: 0,
              title: draft.newstitle,
              url: "",
              newssource: "",
              newsauthor: "",
              keyword: "",
              image: "",
              newstags: [],
              newsflag: 1024,
              itaccount: {
                id: 0,
                accountname: draft.accountname,
                accountid: draft.accountid,
                avatarurl:
                  "https://img.ithome.com/mpimg/account/" +
                  draft.accountid +
                  ".jpg",
                ischeck: 0,
                userid: -1,
                usernick: "",
                isinternalaccount: true,
              },
              detail: draft.newscontent,
              postdate: draft.addtime,
              hitcount: 66666,
              btheme: false,
              forbidcomment: false,
              commentcount: 0,
              z: "刺客",
            };
            processPassedInNewsInfo(data, callback);
          } else {
            callback({
              success: false,
              message: draftIndo.data
                ? draftIndo.data.message || "加载失败"
                : "请求失败",
            });
          }
        });
      } else {
        callback({
          success: false,
          message: "登录失败",
        });
      }
    });
  }

  function processPassedInNewsInfo(data, callback) {
    newsInfo = data.newsInfo || data;
    config = data.config || {};
    config.cloud = config.cloud || {};
    themeStyle.innerText =
      ":root { --theme-color: " + (config.themeColor || "#d22222") + ";}";
    supportLazyLoad = nativeSupportLazyLoad && config.cloud.h5lazy === "true";
    setFontSize(config.fontSize);
    newsId = newsInfo.newsid;
    isShareMode = config.isShareMode;

    needAutoLoadImage = !(
      config.isMobiNetwork &&
      (config.loadImageOnlyWifi || config.loadImageOnlywifi)
    );
    needAutoLoadGif =
      needAutoLoadImage &&
      (!config.isMobiNetwork || config.loadGifInMobiNetwork);
    var userInfo = rm.getUserInfoSync().userInfo || {};
    var isAdmin = userInfo.ism === "true" || userInfo.isc === "true";
    // 标题
    h1.innerText = newsInfo.title;
    document.body.classList[newsInfo.btheme ? "add" : "remove"]("grey");
    document.body.classList.remove("hide");
    // 作者\发布时间等
    var isItAccount = newsInfo.itaccount && newsInfo.itaccount.accountid > 0;
    if (isItAccount) {
      // IT号来源
      itAccountId = newsInfo.itaccount.accountid;
      normalMeta.style.display = "none";
      itaccountMeta.removeAttribute("style");
      document
        .querySelector(".it_avatar")
        .setAttribute("src", newsInfo.itaccount.avatarurl);
      document.querySelector(".itaccount_meta .nick").innerText =
        newsInfo.itaccount.accountname;
      var time = getDateFromString(newsInfo.postdate);
      var timeStr =
        pad(time.getFullYear(), 4) +
        "-" +
        pad(time.getMonth() + 1, 2) +
        "-" +
        pad(time.getDate(), 2) +
        " " +
        pad(time.getHours(), 2) +
        ":" +
        pad(time.getMinutes(), 2) +
        ":" +
        pad(time.getSeconds(), 2);
      document
        .querySelector(".itaccount_meta")
        .classList[newsInfo.itaccount.isinternalaccount ? "remove" : "add"](
          "it-personal"
        );
      if (
        newsInfo.itaccount.userid > 0 &&
        newsInfo.itaccount.usernick &&
        newsInfo.itaccount.usernick !== newsInfo.itaccount.accountname
      ) {
        timeStr = newsInfo.itaccount.usernick + " · " + timeStr;
      }
      document.querySelector(".itaccount_meta .time").innerText = timeStr;
      followBtn.initState(newsInfo.itaccount.accountid);
    } else {
      // IT之家来源
      itAccountId = 0;
      itaccountMeta.style.display = "none";
      normalMeta.removeAttribute("style");
      var time = getDateFromString(newsInfo.postdate);
      document.querySelector(".time").innerText =
        pad(time.getFullYear(), 4) +
        "-" +
        pad(time.getMonth() + 1, 2) +
        "-" +
        pad(time.getDate(), 2) +
        " " +
        pad(time.getHours(), 2) +
        ":" +
        pad(time.getMinutes(), 2) +
        ":" +
        pad(time.getSeconds(), 2);
      var from = newsInfo.newssource;
      if (!isEmpty(newsInfo.newsauthor)) {
        from += "(" + newsInfo.newsauthor + ")";
      }
      document.querySelector(".author").innerText = from;
    }
    if (isAdmin && !isShareMode) {
      document.body.classList.add("admin");
      loadViewCount(newsInfo.hitcount);
    }

    // 正文
    parseNewsBody(newsInfo);
    // 责编\纠错
    editorDom.innerText = newsInfo.z;
    // 打赏
    if (newsInfo.reward === "1") {
      rewardDom.removeAttribute("style");
      loadRewardList();
    } else {
      rewardDom.style.display = "none";
    }
    // 浏览器标题
    title.innerText = newsInfo.title;
    newsInfoLoaded = true;
    if (isShareMode) {
      document.body.classList.add("share-mode");
      document.body.classList.remove("night");
    } else {
      if (rm.getEnv().appver > 8.209) {
        document.body.classList[config.isDark ? "add" : "remove"]("night");
      }
    }
    setNewsInfoTimer = setTimeout(function () {
      callback({
        success: true,
        hasIframe: hasIframe,
        hasPreCode: hasPreCode,
        hasTable: hasTable,
        hasVideo: hasVideo,
      });
    }, 16);
  }

  // 设置一个初始高度
  // var screenHeight = rm.getSystemInfoSync().systemInfo.activityHeight;
  // if(screenHeight){
  //   document.body.style.height = screenHeight + "px";
  // }

  // 调试时主动索取数据
  if (window.location.href.indexOf("test=1") !== -1) {
    rm.sendMessage({
      name: "onReload",
      newsId: rm.getEnv().platform === "iOS" ? 625666 : 0,
    });
  }

  function loadRewardList() {
    var api =
      "https://dyn.ithome.com/api/newsreward/query?newsid=" +
      newsId +
      "&userhash=";
    var listDom = document.querySelector(".reward_list");
    listDom.innerHTML = "";
    var rewardTotalDom = document.querySelector(".reward_total");
    rewardTotalDom.style.display = "none";
    document.querySelector(".reward-button").onclick = function () {
      rm.vibrate();
      rm.sendMessage(
        {
          name: "requestNewsReward",
          itAccountId: itAccountId,
          newsId: newsInfo.newsid,
          authorName: newsInfo.newsauthor,
          newsUrl: getNewsUrl(newsInfo).url,
          newsImage: newsInfo.image,
        },
        function (res) {
          if (res.success) {
            loadRewardList();
          }
        }
      );
    };
    rm.request(
      {
        url: api,
      },
      function (res) {
        if (res.statusCode === 200 && res.data.success) {
          var listHtml = "";
          res.data.content.users.forEach(function (user) {
            listHtml +=
              '<img src="' +
              getAvatarAddress(user.UserId) +
              '" onerror="this.src=\'imgs/avatar_default_rect.png\'"/>';
          });
          if (res.data.content.count > res.data.content.users.length) {
            listHtml += '<img src="imgs/more_reward.png">';
          }
          listDom.innerHTML = listHtml;
          if (res.data.content.count > 0) {
            rewardTotalDom.querySelector(".reward_total_count").innerText =
              res.data.content.count;
            rewardTotalDom.removeAttribute("style");
          }
          listDom.onclick = function () {
            rm.vibrate();
            rm.sendMessage({
              name: "showRewardListDialog",
              itAccountId: itAccountId,
              newsId: newsInfo.newsid,
              authorUserId: newsInfo.ui || 0,
              rewardList: res.data.content,
            });
          };
        }
      }
    );
  }

  ////////////////////////////////////////
  ///////////                //////////////
  //////////  文章加载后的处理  /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  function postProcessHtml(node) {
    // 首屏图片懒加载
    // 识别gif
    var gifs = node.querySelectorAll('img[data-orignal*=".gif"]');
    for (var i = 0; i < gifs.length; i++) {
      var img = gifs[i];
      img.classList.add("gif");
    }
    if (needAutoLoadImage) {
      onWindowScroll();
    }

    checkTable(node);

    // 链接点击
    anchorHelper.process(node);

    // 视频处理
    var players = node.querySelectorAll(".ithome_super_player");
    hasVideo = players.length > 0;
    if (hasVideo) {
      for (var i = 0; i < players.length; i++) {
        var player = players[i];
        new Player(player);
      }
    }

    // 投票处理
    var votes = node.querySelectorAll("p[id^=vote]");
    for (var i = 0; i < votes.length; i++) {
      var vote = votes[i];
      new Vote(vote);
    }

    // 代码高亮
    checkCodeHighlight();

    // 直播、圈子等非正常文章自动重定向
    if (newsInfo.url) {
      if (
        newsInfo.url.indexOf("//live.ithome.com/") > 0 ||
        newsInfo.url.indexOf("//quan.ithome.com/") > 0 ||
        newsInfo.url.indexOf("//img.ithome.com/") > 0
      ) {
        rm.redirectTo({
          url: newsInfo.url,
        });
      }
    }

    // 段落评论
    quoteCommentHelper.loadData(newsInfo);

    // 点击复制
    var copyBtns = document.querySelectorAll(".click_to_copy_btn");
    var copyFunc = function (e) {
      e.preventDefault();
      rm.vibrate();
      rm.setClipboardData(e.target.innerText, function (res) {
        rm.toast({
          data: "复制成功",
          duration: 2000,
        });
      });
    };
    for (var i = 0; i < copyBtns.length; i++) {
      var btn = copyBtns[i];
      btn.onclick = copyFunc;
    }

    // bilibili视频
    hasIframe = content.querySelectorAll("iframe").length > 0;
    if (hasIframe) {
      checkBilibili();
    }

    // 目录生成
    contentsChecker.check();

    // 灰色新闻
    if (newsInfo.btheme) {
      rm.sendMessage({
        name: "changePageColorToGrey",
        reason: [],
      });
    }

    // 分享模式
    if (isShareMode) {
      dealWithShareMode();
    }

    // 点击统计
    clickFeedback();
  }

  ////////////////////////////////////////
  ///////////                //////////////
  //////////  加载前html预处理  /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  function preProcessNewsHtml(html) {
    // 移除脚本
    html = html.replace(/<script(.*?)script>/gi, "");
    // 图片宽度处理
    var imgsReg =
      /<img[ ]*src=[ '"](.*?)[' "][ ]*w=[ '"](\d+)[' "][ ]*h=[ '"](\d+)[' "](.*?)>/gi;
    var imgReg =
      /<img[ ]*src=[ '"](.*?)[' "][ ]*w=[ '"](\d+)[' "][ ]*h=[ '"](\d+)[' "](.*?)>/i;
    var imgMatch = html.match(imgsReg);
    if (imgMatch && imgMatch.length > 0) {
      for (var i = 0; i < imgMatch.length; i++) {
        var img = imgMatch[i];
        var imgInfo = img.match(imgReg);
        if (imgInfo && imgInfo.length == 5) {
          var width = parseInt(imgInfo[2]);
          var height = parseInt(imgInfo[3]);
          var ratio = (width * 1.0) / height;
          width = Math.min(width, paragraphWidth);
          height = parseInt(width / ratio);
          html = html.replace(
            img,
            '<img src="' +
              imgInfo[1] +
              '" width="' +
              width +
              '" height="' +
              height +
              '" w="' +
              imgInfo[2] +
              '" h="' +
              imgInfo[3] +
              '"' +
              imgInfo[4] +
              ">"
          );
        }
      }
    }
    // 图片懒加载
    var imgNormalReg = /<img[ ]*src=[ '"](.*?)[' "](.*?)>/gi;
    var imgReplaceTo =
      '<img data-orignal="$1" src="imgs/transparent.png" onclick="clickImg(this)" $2>';
    if (needAutoLoadImage && supportLazyLoad && !isShareMode) {
      imgReplaceTo =
        '<img src="$1" loading="lazy" onclick="clickImg(this)" $2>';
    }
    html = html.replace(imgNormalReg, imgReplaceTo);
    if (needAutoLoadImage && !isShareMode) {
      if (!supportLazyLoad) {
        html = html.replace("data-orignal=", "src=");
        html = html.replace("data-orignal=", "src="); // 前两张图片不懒加载
      } else {
        html = html.replace('loading="lazy"', "");
        html = html.replace('loading="lazy"', ""); // 前两张图片不懒加载
      }
    }
    html = getEmotionHtml(html, "img", function (node) {
      node.setAttribute("onclick", "clickImg(this)");
    });
    return html;
  }

  function getPropHtml(data) {
    if (!isEmpty(data.detailnew)) {
      if (isLogin()) {
        return rm
          .decryptSync({ text: data.detailnew, key: "(#i@x*l9" })
          .data.replace("ithome-encrypt-news-content", "");
      }
      return '<p>文章需登录后查看，<span class="s_link" onclick="decryptNews()">点此登录</span>。</p>';
    }
    return data.detail;
  }

  function parseNewsBody(data) {
    // 获取html，可能是加密文章，需登录后解密
    var html = getPropHtml(data);
    // html预处理
    content.innerHTML = preProcessNewsHtml(html);
    // 处理投票等
    postProcessHtml(content);
  }

  function decryptNews() {
    doAfterLogin(function () {
      parseNewsBody(newsInfo);
    }, "登录后查看文章");
  }

  function checkCodeHighlight() {
    var pres = document.querySelectorAll("pre");
    hasPreCode = pres.length > 0;
    if (!hasPreCode) {
      return;
    }
    var backList = [];
    for (var i = 0; i < pres.length; i++) {
      var pre = pres[i];
      var key = "pre-code-" + i;
      backList.push({
        key: key,
        code: pre.innerText,
      });
      pre.setAttribute("data-key", key);
      pre.classList.add("prettyprint");
      pre.classList.add("linenums");
    }
    var addCopyBtn = function () {
      for (var i = 0; i < pres.length; i++) {
        var pre = pres[i];
        var key = pre.getAttribute("data-key");
        var targetCode = backList.find(function (item) {
          return item.key === key;
        });
        if (targetCode) {
          var bar = document.createElement("div");
          bar.classList.add("pre-bar");
          var barTitle = document.createElement("span");
          barTitle.classList.add("pre-bar-title");
          barTitle.innerText = "代码";
          var copyBtn = document.createElement("span");
          copyBtn.classList.add("pre-bar-copy");
          copyBtn.innerText = "[复制]";
          copyBtn.onclick = function () {
            rm.vibrate();
            rm.setClipboardData(targetCode.code, function (res) {
              toast(res.success ? "代码已复制" : "复制出错");
            });
          };
          bar.appendChild(barTitle);
          bar.appendChild(copyBtn);
          pre.insertAdjacentElement("beforebegin", bar);
        }
      }
    };

    if (typeof prettyPrint !== "undefined") {
      prettyPrint();
      addCopyBtn();
    } else {
      var script = document.createElement("script");
      script.onload = function () {
        prettyPrint();
        addCopyBtn();
      };
      script.src = "js/prettify.js";
      document.body.appendChild(script);
    }
  }

  window.decryptNews = decryptNews;

  ////////////////////////////////////////
  ///////////                //////////////
  //////////       链接元素   /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  var contentsChecker = new ContentsChecker();
  function ContentsChecker() {
    this.check = function () {
      if (
        (content.innerText || "").length > 3060 &&
        (content.querySelectorAll("h2").length > 1 ||
          content.querySelectorAll("h2,h3").length >= 5)
      ) {
        var resTitles = getNewsTitles();
        rm.sendMessage({
          name: "onGetNewsTitles",
          titles: resTitles.titles,
          current: resTitles.current,
        });
      }
    };

    rm.onReceiveMessage("requestNewsSubTitle", function (data, callback) {
      callback(getNewsTitles());
    });

    rm.onReceiveMessage("scrollToNewsSubTitle", function (data, callback) {
      var titles = content.querySelectorAll("h2,h3");
      var dom = titles[data.index];
      var rect = dom.getBoundingClientRect();
      var to = rect.top - document.body.getBoundingClientRect().top - 80;
      try {
        window.scrollTo({ top: to, behavior: "smooth" });
      } catch (error) {
        window.scrollTo(0, to);
      }
    });

    function getNewsTitles() {
      var titles = content.querySelectorAll("h2,h3");
      var resTitles = [];
      for (var index = 0; index < titles.length; index++) {
        var title = titles[index];
        var type = title.tagName.toLowerCase();
        resTitles.push({
          title: title.innerText, //(type === "h3" ?  "• ":"") +
          type: type,
          top:
            rm.getEnv().appver > 8.08
              ? parseInt(
                  title.getBoundingClientRect().top -
                    document.body.getBoundingClientRect().top
                )
              : -1,
        });
      }
      var scrollHeight = window.scrollY;
      var windowHeight = window.innerHeight || window.clientHeight;
      var firstUnreachedTitle = -1;
      for (var i = 0; i < resTitles.length; i++) {
        if (
          firstUnreachedTitle == -1 &&
          resTitles[i].top - scrollHeight > windowHeight - 80
        ) {
          firstUnreachedTitle = i;
          break;
        }
      }
      if (firstUnreachedTitle == -1) {
        firstUnreachedTitle = resTitles.length;
      }
      return { titles: resTitles, current: firstUnreachedTitle - 1 };
    }
  }

  ////////////////////////////////////////
  ///////////                //////////////
  //////////       链接元素   /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  var anchorHelper = new AnchorHelper();
  function AnchorHelper() {
    this.process = function (container) {
      // 普通链接
      var links = container.querySelectorAll("a");
      for (var i = 0; i < links.length; i++) {
        var link = links[i];
        link.onclick = onClick;

        // 磁力链接处理
        if (
          link.classList.contains("ed2k-link") ||
          link.classList.contains("magnet-link")
        ) {
          var copyDom = document.createElement("span");
          copyDom.classList.add("copyLinkBtn");
          copyDom.innerText = "复制链接";
          copyDom.onclick = function () {
            rm.vibrate();
            rm.setClipboardData(link.getAttribute("href"), function (res) {
              if (res.success) {
                rm.toast({
                  data: "链接已复制",
                });
              }
            });
          };
          link.insertAdjacentElement("afterend", copyDom);
        }

        // 去下载描述文件
        if (link.id === "to-app-iosfiles") {
          link.innerHTML = "客户端内点此直达描述文件下载";
          link.setAttribute(
            "href",
            "https://img.ithome.com/app/iosprofiles/index.html?hidemenu=1&fitsystemWindow=1&isrmmp=1&keeptitle=1"
          );
        }

        // 链接中的图片处理
        var imgs = link.querySelectorAll("img");
        var isHighQualityImage = false;
        if ((link.innerText || "").trim().length === 0 && imgs.length === 1) {
          if (!link.classList.contains("ithome_super_player"))
            link.classList.add("link_rich_content");
          var href = link.getAttribute("href");
          var imgUrl = getRealSrc(imgs[0]);
          if (imgUrl.indexOf(href) === 0) {
            isHighQualityImage = true;
            // 是原图模式图片
            link.setAttribute("href", "javascript:void(0);");
            imgs[0].setAttribute("data-highquality", href);
          }
        }
        if (!isHighQualityImage) {
          // 非原图模式下链接中的图片都自动显示
          for (var index = 0; index < imgs.length; index++) {
            var img = imgs[index];
            var realSrc = getRealSrc(img);
            if (realSrc && img.getAttribute("src") !== realSrc) {
              img.setAttribute("src", realSrc);
            }
            img.setAttribute("data-noneclick", "yes");
          }
        }
      }

      // 三方平台链接：微博、抖音
      var needCheckPlatforms = [
        {
          scheme: "sinaweibo://",
          host: "userinfo",
        },
      ];
      if (rm.getEnv().platform === "Android") {
        needCheckPlatforms.push({
          scheme: "snssdk1128://",
        });
      }
      needCheckPlatforms.forEach(function (platform) {
        var scheme = platform.scheme;
        var schemeUrl = scheme + (platform.host || "");
        var selector = 'a[data-androidurl*="' + scheme + '"]';
        var targetUrls = container.querySelectorAll(selector);
        if (targetUrls.length > 0) {
          rm.canOpenURL({ url: schemeUrl }, function (res) {
            if (res.status !== 1) {
              for (var index = 0; index < targetUrls.length; index++) {
                var element = targetUrls[index];
                var url = element.getAttribute("href") || "";
                if (url.toLowerCase().trim().indexOf("http") === 0) {
                  element.removeAttribute("data-androidurl");
                  element.removeAttribute("data-iosurl");
                }
              }
            }
          });
        }
      });

      //之家辣品文章，根据是否安装最会买，跳转不同的链接
      var zuihuimaiBuy = document.querySelectorAll("a[data-zuihuimaibuy]");
      var zuihuimaidown = document.getElementById("zuihuimaidown");
      if (zuihuimaiBuy.length > 0 || zuihuimaidown) {
        rm.canOpenURL(
          {
            url: "zuihuimai://openurl",
            getDetail: false,
          },
          function (res) {
            if (res.status === 1) {
              // 最会买购买
              for (var index = 0; index < zuihuimaiBuy.length; index++) {
                var element = zuihuimaiBuy[index];
                var zhmurl = element.getAttribute("data-zuihuimaibuy");
                element.setAttribute("href", zhmurl);
                element.removeAttribute("data-iosurl");
                element.removeAttribute("data-androidurl");
                element.innerText = "点此下单拿返利";
              }
              // 最会买App下载
              if (zuihuimaidown) {
                zuihuimaidown.setAttribute("href", "zuihuimai://openurl");
                zuihuimaidown.removeAttribute("data-iosurl");
                zuihuimaidown.removeAttribute("data-androidurl");
                zuihuimaidown.innerText = "打开最会买";
              }
            }
          }
        );
      }

      // 之家公众号文章优先跳转到小程序打开，如果检测到未安装微信，则删除链接
      var platAttr =
        rm.getEnv().platform === "iOS" ? "data-iosurl" : "data-androidurl";
      var mpTags = document.querySelectorAll(
        "a[" + platAttr + "^='ithome://openmp?appid=ithome&auto=1']"
      );
      if (mpTags.length > 0) {
        rm.canOpenURL(
          {
            url: "weixin://dl/",
          },
          function (res) {
            if (res.status !== 1) {
              for (var index = 0; index < mpTags.length; index++) {
                var element = mpTags[index];
                element.removeAttribute(platAttr);
              }
            }
          }
        );
      }

      // 商品卡片
      var cards = document.querySelectorAll(".card.main-site");
      for (var index = 0; index < cards.length; index++) {
        var card = cards[index];
        var mallName = card.querySelector(".mall-data");
        if (mallName) {
          var mallToken = "none";
          switch (mallName.innerText) {
            case "天猫":
              mallToken = "tmall";
              break;
            case "淘宝":
              mallToken = "taobao";
              break;
            case "京东":
              mallToken = "jingdong";
              break;
            case "拼多多":
              mallToken = "pinduoduo";
              break;
          }
          card.classList.add(mallToken);
        }
        var price = card.querySelector(".price");
        if (price) {
          price.innerHTML = price.innerHTML.replace(
            /(\d+)(\.\d+)?/g,
            '<span class="price-num">$1$2</span>'
          );
        }
      }
    };

    function onClick(e) {
      e.preventDefault();
      var tag = e.currentTarget;
      var platAttr =
        rm.getEnv().platform === "iOS" ? "data-iosurl" : "data-androidurl";
      var url = tag.getAttribute("href");
      if (
        isReviewMode &&
        (url.indexOf("jd.com") !== -1 ||
          url.indexOf("taobao.com") !== -1 ||
          url.indexOf("tmall.com") !== -1)
      ) {
        // rm.vibrate();
        rm.navigateTo({
          url: url,
          openExternal: true,
        });
        return;
      }
      var platformUrl = tag.getAttribute(platAttr);
      var appUrl = tag.getAttribute("data-appurl");
      if (!isEmpty(platformUrl)) {
        url = platformUrl;
      } else if (!isEmpty(appUrl)) {
        url = appUrl;
      }
      if (!isEmpty(url)) {
        if (url.trim().indexOf("#") === 0) {
          // 锚链
          var to = document.querySelector(url);
          if (to) {
            var top = to.getBoundingClientRect().top;
            try {
              window.scrollTo({ top: top, behavior: "smooth" });
            } catch (e) {
              window.scrollTo(0, top);
            }
          }
        } else if (url.indexOf("javascript:") === 0) {
          eval(url.substring("javascript:".length));
        } else {
          // 普通链接
          rm.navigateTo({
            url: url,
          });
          // rm.vibrate();
        }
      }
    }
  }

  function checkBilibili() {
    if (isShareMode) {
      return;
    }
    var iframeVideos = document.querySelectorAll('iframe[src*="bilibili"]');
    var normalLinks = document.querySelectorAll('a[href*="bilibili"]');
    if (normalLinks.length > 0 || iframeVideos.length > 0) {
      rm.canOpenURL({ url: "bilibili://space/13938355" }, function (res) {
        if (res.status === 1) {
          for (var i = 0; i < iframeVideos.length; i++) {
            (function (index) {
              var iframe = iframeVideos[index];
              var scheme = "bilibili://video/" + vid;
              var src = __parseUrl(iframe.src);
              if (src.host === "player.bilibili.com") {
                var vid = src.params.bvid || src.params.aid;
                var url = "";
                if (
                  src.params.bvid &&
                  src.params.bvid.toLowerCase().indexOf("bv") !== 0
                ) {
                  //修正BV号
                  vid = "bv" + vid;
                }
                if (!isEmpty(vid)) {
                  url = "https://www.bilibili.com/video/" + vid;
                }
                if (!isEmpty(url)) {
                  var scheme = "bilibili://video/" + vid;
                  videoParser.parse(url, function (res) {
                    if (res.success) {
                      var isIthome = res.data.author === "IT之家的哔哩哔哩视频";
                      var parent = iframe.parentNode;
                      parent.position = "relative";
                      if (isIthome) {
                        iframe.insertAdjacentHTML(
                          "afterend",
                          '<span class="open-bilibili ithome" onclick="openbilibili(\'bilibili://space/13938355\')"><span>关注IT之家B站号，看更多精彩视频</span><span class="btn">立即关注</span></span>'
                        );
                      } else {
                        iframe.insertAdjacentHTML(
                          "afterend",
                          '<span class="open-bilibili" onclick="openbilibili(\'' +
                            scheme +
                            '\')"><span>打开bilibili观看视频</span><span class="btn">打开</span></span>'
                        );
                      }
                    }
                  });
                }
              }
            })(i);
          }
          for (var i = 0; i < normalLinks.length; i++) {
            var link = normalLinks[i];
            var blUrl = getBilibiliUrlInfo(link.getAttribute("href"));
            if (!isEmpty(blUrl.scheme)) {
              link.setAttribute("data-url", blUrl.scheme);
              link.setAttribute("href", blUrl.scheme);
            }
          }
        }
      });
    }
  }

  ////////////////////////////////////////
  ///////////                //////////////
  //////////       图片点击    /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  function clickImg(target) {
    // var target = e.target;
    if (
      target.classList.contains("emotion") ||
      target.classList.contains("ruanmei-emotion")
    ) {
      var alt = target.getAttribute("title");
      if (!isEmpty(alt)) {
        rm.toast({
          data: alt,
        });
      }
      target.classList.add("shake");
      setTimeout(function () {
        target.classList.remove("shake");
      }, 5000);
      return;
    }
    var realSrc = getRealSrc(target);
    // if (target.classList.contains("loading")) {
    //   return;
    // } else
    if (realSrc && target.getAttribute("src") !== realSrc) {
      // var image = document.createElement("img");
      target.onload = function () {
        // target.setAttribute("src", realSrc);
        if (target.getAttribute("src") !== "imgs/transparent.png") {
          target.classList.remove("loading");
          target.classList.add("loaded");
          target.removeAttribute("data-orignal");
        }
      };
      target.onerror = function () {
        target.removeAttribute("src");
        target.classList.remove("loading");
      };
      target.src = realSrc;
      target.classList.add("loading");
    } else if (!target.hasAttribute("data-noneclick")) {
      if (target.hasAttribute("data-highquality")) {
        realSrc = target.getAttribute("data-highquality");
      }
      var resImgs = [];
      var imgs = content.getElementsByTagName("img");
      for (var i = 0; i < imgs.length; i++) {
        var element = imgs[i];
        if (
          !element.hasAttribute("data-noneclick") &&
          element.className.indexOf("ruanmei-emotion") === -1
        ) {
          var realImgUrl = getRealSrc(element);
          if (element.hasAttribute("data-highquality")) {
            realImgUrl = element.getAttribute("data-highquality");
          }
          resImgs.push(realImgUrl);
        }
      }
      rm.previewImage({
        url: realSrc,
        anchor: target.getBoundingClientRect(),
        imgUrls: resImgs,
      });
      // rm.vibrate();
    }
  }
  window.clickImg = clickImg;
  window.openbilibili = function (url) {
    rm.navigateTo({
      url: url,
    });
    rm.vibrate();
  };
  ////////////////////////////////////////
  ///////////                //////////////
  //////////       滚动监听    /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  var lastScrollY = -99;
  function onWindowScroll() {
    var docElement = document.documentElement;
    var docBody = document.body;
    var scrollTop = docElement.scrollTop || docBody.scrollTop;
    var bodyHeight = docElement.clientHeight || docBody.clientHeight;
    var windowHeight = window.innerHeight;
    var bodyTopEdge = document.body.getBoundingClientRect().top;
    // 图片懒加载
    if (
      !isShareMode &&
      needAutoLoadImage &&
      !lazyLoadFinished &&
      !supportLazyLoad
    ) {
      setTimeoutOnce(
        "lazyLoad",
        function () {
          var imgs = document.querySelectorAll("img[data-orignal]");
          if (imgs.length === 0 && newsInfoLoaded) {
            lazyLoadFinished = true;
          }
          for (var i = 0; i < imgs.length; i++) {
            var img = imgs[i];
            var isLoading = img.classList.contains("loading");
            var realUrl = img.getAttribute("data-orignal");
            var isGif = img.classList.contains("gif");
            if (!isLoading && !(!needAutoLoadGif && isGif)) {
              if (realUrl && realUrl.length > 0) {
                var bound = img.getBoundingClientRect();
                if (scrollTop + 1.5 * windowHeight >= bound.top - bodyTopEdge) {
                  // var image = document.createElement("img");
                  img.onload = function () {
                    if (img.getAttribute("src") !== "imgs/transparent.png") {
                      img.classList.remove("loading");
                      img.classList.add("loaded");
                      img.removeAttribute("data-orignal");
                    }
                  };
                  img.onerror = function () {
                    img.removeAttribute("src");
                    img.classList.remove("loading");
                  };
                  img.src = realUrl;
                  img.classList.add("loading");
                } else {
                  break;
                }
              } else {
                img.removeAttribute("data-orignal");
              }
            }
          }
        },
        50,
        200
      );
    }

    lastScrollY = scrollTop;
  }
  window.addEventListener("scroll", onWindowScroll);

  window.openItAccount = function () {
    rm.vibrate();
    rm.navigateTo({
      url: "ithome://wmpage?id=" + itAccountId,
    });
  };

  window.openAuthorPage = function () {
    if (newsInfo.user && newsInfo.user.userid) {
      rm.vibrate();
      rm.navigateTo({
        url: "ithome://userpage?id=" + newsInfo.user.userid + "&tab=article",
      });
    }
  };
  window.openErrorPick = function () {
    rm.vibrate();
    var intent = {
      newsId: newsId,
    };
    doAfterLogin(function () {
      rm.navigateTo({
        url: "https://img.ithome.com/app/errorfeedback/index.html?hidemenu=1",
        intent: intent,
      });
    }, "登录后纠错");
  };
  var lastSubmitCommentType = 0;
  var appReleaseArticleReg =
    /(辣品|云日历|IT之家|旗鱼浏览器)(安卓|iOS|微信小程序|小程序|UWP|macOS).+(发布|更新|上线|：)/;
  rm.onReceiveMessage("getCommentPlaceholder", function (data, callback) {
    var replyToComment =
      typeof data !== typeof undefined && data != null
        ? JSON.parse(data.replyToComment || "{}")
        : {};
    var isReplyFloor = replyToComment.Ci > 0;
    var reReplyToMainFloor =
      isReplyFloor && replyToComment.SF.indexOf("#") == -1;
    var resultHint = "文明发言，友善交流。";
    var userInfo = getUserInfo();
    var isToMe = userInfo.userid > 0 && userInfo.userid == replyToComment.Ui;
    var isM = userInfo.ism && userInfo.ism !== "false";
    var isN = userInfo.isn && userInfo.isn !== "false";
    var isC = userInfo.isc && userInfo.isc !== "false";
    var isE = userInfo.ise && userInfo.ise !== "false";
    var isRM = isE || isC || isM;
    var matchResult = newsInfo.title
      .replace(/ /g, "")
      .match(appReleaseArticleReg);
    var isAppReleaseNews = matchResult && matchResult.length > 1;
    var releaseAppName = isAppReleaseNews ? matchResult[1] : "";
    // var isIthomeReleaseNews = releaseAppName === "IT之家";
    if (!isReplyFloor) {
      // 主楼
      lastSubmitCommentType = 0;
      var hour = new Date().getHours();
      if (isAppReleaseNews && releaseAppName !== "辣品") {
        resultHint = "讲真的，IT之家真是越来越好用了呢~(*￣︶￣)".replace(
          "IT之家",
          releaseAppName
        );
      } else if (newsInfo.btheme) {
        resultHint = "敬畏生命，文明发言";
      } else if (hour >= 0 && hour <= 2) {
        resultHint = "Hi，{name}。夜深了，注意休息。".replace(
          "{name}",
          userInfo.nickname
        );
      }
    } else if (isToMe) {
      // 回复自己
      lastSubmitCommentType = 2;
      if (reReplyToMainFloor) {
        resultHint = "请输入要补充的内容~️";
      } else {
        resultHint = "emm...自言自语";
      }
    } else {
      // 回复别人
      lastSubmitCommentType = 1;
      if (
        isAppReleaseNews &&
        !isRM &&
        replyToComment.Ir &&
        replyToComment.M == 1
      ) {
        resultHint = "反馈问题？还请您尽可能详细描述~";
      } else if (!isRM && replyToComment.Ir && replyToComment.M == 1) {
        resultHint = "想对产品部帅哥/美女说...";
      } else if (!isRM && replyToComment.Ir && replyToComment.M == 2) {
        resultHint = "想对小编说...";
      } else if (
        rm.getSystemInfoSync().systemInfo &&
        rm.getSystemInfoSync().systemInfo.modelName == replyToComment.Ta
      ) {
        resultHint = "同是天涯好机友，相逢何必曾相识~";
      } else if (!isRM && isN) {
        resultHint = "文明交流，尊重他人，以身作则";
      }
    }

    callback({
      placeholder: resultHint,
    });
  });

  if (isIOS && typeof ResizeObserver !== "undefined") {
    var objResizeObserver = new ResizeObserver(function (entries) {
      rm.sendMessage({
        name: "bodySizeChanged",
        height: document.body.clientHeight,
        width: document.body.clientWidth,
      });
    });
    objResizeObserver.observe(document.body);
  }

  // 主题变化
  rm.onAppThemeChanged(function (status) {
    var isDark = status.isDark;
    var isAmoled = status.useAmoledBlack;
    if (isShareMode || isItPreviewMode) {
      isDark = false;
      isAmoled = false;
    }
    document.body.classList[isDark ? "add" : "remove"]("night");
    document.body.classList[isDark && isAmoled ? "add" : "remove"]("amoled");
  });

  // 文字大小、颜色等变化
  rm.onReceiveMessage("onFontSizeChanged", function (data) {
    setFontSize(data.fontSize);
  });

  // 获取文本内容
  rm.onReceiveMessage("onGetNewsText", function (data, callback) {
    callback(getNewsContent(data ? data.maxLength : 0));
  });

  // 通知原生一切准备就绪
  rm.notifyNativeReady();
});

function getNewsContent(maxLength) {
  var res = {
    title: h1.innerText,
  };
  var copyDom = document.createElement("div");
  copyDom.innerHTML = content.innerHTML;
  addEndForDoms(copyDom, "h2");
  addEndForDoms(copyDom, "h3");
  // remove doms
  removeAllElement(copyDom, "dir");
  removeAllElement(copyDom, "pre");
  removeAllElement(copyDom, "table");
  removeAllElement(copyDom, "iframe");
  removeAllElement(copyDom, "video");
  removeAllElement(copyDom, "p[id^=vote]");
  removeAllElement(copyDom, ".ithome_super_player");
  var contentStr = copyDom.innerText;
  var contents = [contentStr];
  if (maxLength && maxLength > 10 && contentStr.length > maxLength) {
    contents = [];
    var lines = splitWords(contentStr, ["。", "！", "？", "……", "；", "："]);
    var tempStr = "";
    lines.forEach(function (line) {
      if (!isEmpty(tempStr) && (tempStr + line).length > maxLength) {
        contents.push(tempStr);
        tempStr = line;
      } else {
        tempStr += line;
      }
    });
    if (!isEmpty(tempStr)) {
      contents.push(tempStr);
    }
  }
  res.contents = contents;
  return res;
}

function splitWords(contentStr, words) {
  var res = [contentStr];
  words.forEach(function (word) {
    res = splitWord(res, word);
  });
  return res;
}
function splitWord(contents, word) {
  var res = [];
  contents.forEach(function (str, j) {
    var lines = str.split(word);
    lines.forEach(function (seg, index) {
      if (index !== lines.length - 1) {
        lines[index] = seg + word;
      }
    });
    res = res.concat(lines);
  });
  return res;
}
function addEndForDoms(targetDom, selector) {
  var doms = targetDom.querySelectorAll(selector);
  for (var i = 0; i < doms.length; i++) {
    var dom = doms[i];
    if (dom) dom.innerHTML = dom.innerHTML + "。";
  }
}
function removeAllElement(targetDom, selector) {
  var doms = targetDom.querySelectorAll(selector);
  for (var i = 0; i < doms.length; i++) {
    var dom = doms[i];
    if (dom) dom.remove();
  }
}

function setFontSize(newSize) {
  newSize = !isEmpty(newSize) ? newSize : null;
  if (fontSize !== newSize) {
    if (fontSize) {
      document.documentElement.classList.remove("font-size-" + fontSize);
    }
    fontSize = newSize;
    if (newSize) {
      document.documentElement.classList.add("font-size-" + newSize);
      localStorage.setItem("fontSize", newSize);
    } else {
      localStorage.removeItem("fontSize");
    }
  }
}

function resizerPatchfunction() {
  clearTimeout(resizeTimer);
  resizeTimer = setTimeout(function () {
    NestedWebViewApi && NestedWebViewApi.onResize();
  }, 200);
}

////////////////////////////////////////
///////////                //////////////
//////////    段落评论工具  /////////////
//////////                 /////////////
////////////////////////////////////////
var quoteCommentHelper = new QuoteCommentHelper();
function QuoteCommentHelper() {
  var that = this;
  this.newsId = 0;
  this.isCommentBubbleEnable = false;
  this.lastQuoteRange = {};
  // 初始化数据
  this.loadData = function (newsInfo) {
    that.newsId = newsInfo.newsid;
    var isCommentEnable = !newsInfo.forbidcomment && !getUserInfo().nocomment;
    if (isCommentEnable && !isShareMode) {
      rm.getSettings({ ignoreCloud: true }, function (res) {
        that.isCommentBubbleEnable =
          res.success &&
          (res.settings.enableCommentBubble ||
            typeof res.settings.enableCommentBubble === "undefined");
        if (that.isCommentBubbleEnable) {
          loadParagraphComment();
        }
      });
    }
  };
  // 获取选区信息
  this.getSelection = function () {
    var selectHtml = getSelectionHtml();
    var res = {
      html: selectHtml.html,
      text: selectHtml.text,
      newsId: newsId,
    };
    if (window.getSelection && window.getSelection()) {
      var selection = window.getSelection();
      res.startP = getAnchorPmark(selection.anchorNode);
      res.endP = getAnchorPmark(selection.extentNode);
      res.token = uuid();
      that.lastQuoteRange = {
        range: selection.getRangeAt(0).cloneRange(),
        text: res.text,
        token: res.token,
      };
    }
    return res;
  };
  // 定位段落并高亮
  this.highlightNewsParagraph = function (data) {
    var cancelList = document.querySelectorAll("*[data-highlight=quote]");
    for (var index = 0; index < cancelList.length; index++) {
      var element = cancelList[index];
      normalizeNode(element);
    }
    var id = data.id;
    var text = data.text;
    var dom = document.querySelector("*[data-vmark*='" + id + "']");
    if (id.toLowerCase() === "head") {
      dom = document.querySelector("h1");
    }
    var to = 0;
    if (dom) {
      var rect = dom.getBoundingClientRect();
      to =
        rect.top -
        document.body.getBoundingClientRect().top -
        window.innerHeight / 3;
      if (!data.onlyGetPosition) {
        window.scrollTo(0, to);
      }
      dom.classList.add("highlight-quote-bg");
      setTimeout(function () {
        dom.classList.remove("highlight-quote-bg");
      }, 520);
      try {
        setTimeout(function () {
          highlightKeyWords(dom, [
            {
              key: text,
              tip: "",
              singleindex: -1,
            },
          ]);
        }, 650);
      } catch (error) {}
    }
    return {
      success: !!dom,
      message: !!dom ? "已找到段落" : "段落已失去关联",
      top: to,
    };
  };

  // 评论发布后高亮
  this.quoteCommentSubmit = function (data) {
    var info = typeof data === "string" ? JSON.parse(data) : data;
    var pmark = info.startP;

    var selector = "*[data-vmark='" + pmark + "']";
    if (pmark === "head") {
      selector = ".title";
    }

    var p = document.querySelector(selector);
    if (p && !isEmpty(p.innerText, true)) {
      // 更新评论数量
      var mark = p.querySelector(".comment-quote-mark");
      if (!mark) {
        mark = document.createElement("span");
        mark.className = "comment-quote-mark start-one";
        mark.innerHTML = "<span>" + 1 + "</span>";
        mark.setAttribute("role", "option");
        mark.setAttribute("aria-label", "段落评论," + 1 + "条");
        p.insertAdjacentElement("beforeend", mark);
      } else {
        var currentCount = parseInt(mark.innerText);
        var newCount = currentCount + 1;
        mark.innerHTML = "<span>" + newCount + "</span>";
        mark.setAttribute("aria-label", "段落评论," + newCount + "条");
        if (newCount > 9) {
          mark.classList.add("red");
        }
        if ((newCount + "").indexOf("1") === 0) {
          mark.classList.add("start-one");
        } else {
          mark.classList.remove("start-one");
        }
      }
      mark.onclick = function () {
        rm.vibrate();
        rm.navigateTo({
          url:
            "ithome://paragraphcomment?newsid=" +
            that.newsId +
            "&paragraphid=" +
            pmark,
        });
      };
      // 引用画横线
      if (
        info.token === that.lastQuoteRange.token &&
        info.startP === info.endP &&
        !p.querySelector("dir")
      ) {
        var newdom = document.createElement("span");
        newdom.innerText = that.lastQuoteRange.text;
        newdom.className = "comment-quote-element";
        that.lastQuoteRange.range.deleteContents();
        that.lastQuoteRange.range.insertNode(newdom);
      }
    }
  };
  rm.onReceiveMessage("quoteCommentSubmit", function (data) {
    if (that.isCommentBubbleEnable) {
      that.quoteCommentSubmit(data);
    }
  });
  rm.onReceiveMessage("highLightNewsParagraph", function (data, callback) {
    callback(that.highlightNewsParagraph(data));
  });
  rm.onReceiveMessage("getSelection", function (data, callback) {
    callback(that.getSelection());
  });

  function loadParagraphComment() {
    // 加载段落评论
    rm.request(
      {
        url:
          "https://cmt.ithome.com/api/comment/getparagraphcommentcounts?sn=" +
          rm.encryptSync({ text: that.newsId + "" }).data,
      },
      function (res) {
        if (res.statusCode === 200 && res.data.success) {
          var ps = res.data.content;
          ps &&
            ps.forEach(function (item) {
              var selector = "*[data-vmark='" + item.paragraphId + "']";
              if (item.paragraphId === "head") {
                selector = ".title";
              }
              var p = document.querySelector(selector);
              if (p && !isEmpty(p.innerText, true)) {
                // 更新评论数量
                var mark = p.querySelector(".comment-quote-mark");
                if (!mark) {
                  mark = document.createElement("span");
                  var pText = (p.innerText || "").trim();
                  var endWithMark =
                    ["。", "！", "？", "：", "》", "；", "）", "】"].indexOf(
                      pText[pText.length - 1]
                    ) !== -1;
                  mark.className =
                    "comment-quote-mark" + (!endWithMark ? " large" : "");
                  p.insertAdjacentElement("beforeend", mark);
                }
                if ((item.count + "").indexOf("1") === 0) {
                  mark.classList.add("start-one");
                } else {
                  mark.classList.remove("start-one");
                }
                if (item.count > 9) {
                  mark.classList.add("red");
                }
                mark.innerHTML = "<span>" + item.count + "</span>";
                mark.setAttribute("role", "option");
                mark.setAttribute(
                  "aria-label",
                  "段落评论," + item.count + "条"
                );
                mark.onclick = function () {
                  rm.vibrate();
                  rm.navigateTo({
                    url:
                      "ithome://paragraphcomment?newsid=" +
                      that.newsId +
                      "&paragraphid=" +
                      item.paragraphId,
                  });
                };
              }
            });
        }
      }
    );
  }
}

////////////////////////////////////////
///////////                //////////////
//////////     关注按钮     /////////////
//////////                 /////////////
////////////////////////////////////////
var followBtn = new FollowBtn(document.querySelector(".follow_btn"));
function FollowBtn(ele) {
  var that = this;
  var STATE = {
    UNFOLLOW: 0,
    FOLLOWING: 1,
    FOLLOWED: 2,
    UNFOLLOWING: 3,
  };
  this.userAccountId = 0;
  this.currentState = 0;
  this.STATE = STATE;
  this.initState = function (accountId) {
    that.userAccountId = accountId;
    if (isLogin()) {
      rm.sendMessage(
        {
          name: "app-getFollowState",
          itaccountid: accountId,
          userid: 0,
        },
        function (res) {
          if (res.success) {
            that.currentState = res.isFollowed
              ? STATE.FOLLOWED
              : STATE.UNFOLLOW;
            that.setState(that.currentState);
          } else {
            that.setState(STATE.UNFOLLOW);
          }
          setFollowStateTimer = setTimeout(function () {
            document.querySelector(".follow_btn").classList.add("inited");
          }, 200);
        }
      );
    } else {
      that.setState(STATE.UNFOLLOW);
    }
  };
  this.setState = function (state) {
    Object.values(STATE).forEach(function (value) {
      ele.classList.remove("follow_state_" + value);
    });
    ele.classList.add("follow_state_" + state);
    that.currentState = state;
  };
  this.switchState = function () {
    if (
      that.currentState === STATE.FOLLOWING ||
      that.currentState === STATE.UNFOLLOWING
    ) {
      toast("操作中，请稍候");
      return;
    }
    if (that.userAccountId === 0) {
      toast("初始化中，请稍候");
      return;
    }
    rm.vibrate();
    var oldState = that.currentState;
    var newState =
      that.currentState === STATE.FOLLOWED ? STATE.UNFOLLOW : STATE.FOLLOWED;
    that.setState(
      that.currentState === STATE.FOLLOWED ? STATE.UNFOLLOWING : STATE.FOLLOWING
    );
    doAfterLogin(
      function () {
        var data = {
          name: "app-changeFollowState",
          itaccountid: that.userAccountId,
          userid: 0,
          isAddFollow: newState === STATE.FOLLOWED,
        };
        rm.sendMessage(data, function (res) {
          if (!res.success) {
            toast(res.message || "操作失败");
          }
          setTimeout(
            function () {
              that.setState(res.success ? newState : oldState);
            },
            res.success ? 200 : 0
          );
        });
      },
      function () {
        toast("请登录后关注");
        that.setState(oldState);
      }
    );
  };
  ele.onclick = this.switchState;
}

////////////////////////////////////////
///////////                //////////////
//////////       播放器     /////////////
//////////                 /////////////
////////////////////////////////////////
function Player(ele) {
  var url = ele.getAttribute("href");
  videoParser.parse(url, function (res) {
    if (res.success && !res.data.isiframe) {
      var Vobject = document.createElement("video");
      Vobject.setAttribute("controls", "controls");
      Vobject.setAttribute("preload", "metadata");
      Vobject.setAttribute("src", res.data.video);
      Vobject.setAttribute("playsinline", "true");
      Vobject.setAttribute(
        "poster",
        res.data.poster || "https://img.ithome.com/app/images/transparent.png"
      );
      ele.parentNode.insertBefore(Vobject, ele);
      ele.style.display = "none";
      // ele.classList.remove("ithome_super_player");
    }
  });
}

////////////////////////////////////////
///////////                //////////////
//////////       投票器     /////////////
//////////                 /////////////
////////////////////////////////////////
function Vote(ele) {
  var that = this;
  this.maxCount = 0;
  this.mySelect = [];
  var myosType = "";
  var model = rm.getSystemInfoSync().systemInfo.model;
  if (rm.getEnv().platform === "Android") {
    myosType = "android";
  } else if (rm.getEnv().platform === "iOS") {
    myosType = "iphone";
  }
  this.init = function () {
    that.maxCount = 0;
    that.mySelect = [];
    var voreId = ele.id.replace("vote", "");
    var userId = (rm.getUserInfoSync().userInfo || {}).userid || 0;
    var voteInfoApi =
      "https://dyn.ithome.com/xml/vote/" +
      voreId +
      "_" +
      userId +
      ".xml?r=" +
      new Date().getTime();

    rm.request(
      {
        url: voteInfoApi,
        header: {
          "Content-Type": "application/xml",
        },
      },
      function (res) {
        if (res.statusCode === 200) {
          var xml = res.data;
          var info = xml2json(xml);
          if (!isEmpty(info.vote.voted.value)) {
            info.vote.voted.value =
              info.vote.voted.value.toLowerCase() === "true";
          }
          if (info.vote.los.value) {
            var allowOS = info.vote.los.value;
            if (allowOS.indexOf(myosType) === -1) {
              info.vote.voted.value = true;
            }
          }
          that.maxCount = parseInt(info.vote.votetype.value);
          generateVoteHtml(info);
          bindEvent(info);
        }
      }
    );
  };

  this.init();

  function generateVoteHtml(info) {
    var options = "";
    info.vote.items.item.forEach(function (option, index) {
      if (info.vote.voted.value) {
        options +=
          '<div class="vote-result">' +
          '<span class="vote-result-value">' +
          (index + 1) +
          "、" +
          option.t.value +
          "</span>" +
          '<span class="vote-result-progress"><span class="vote-result-progress-inner vote-result-color-' +
          getColorIndex(index) +
          " vote-result-progress-inner-" +
          option.i.value +
          '"></span></span>' +
          '<span class="vote-result-des">' +
          getWidthPercent(option.c.value, info.vote.total.value) +
          " ( " +
          option.c.value +
          "票 )</span>" +
          "</div>";
      } else {
        options +=
          '<span class="vote-option" data-id="' +
          option.i.value +
          '">' +
          '<span class="vote-radio"><span>✓</span></span>' +
          option.t.value +
          "</span>";
      }
    });
    var html =
      '<div class="vote-container">' +
      '<span class="vote-title">' +
      info.vote.title.value +
      "</span>" +
      '<span class="vote-des">【IT之家调查】 投票人数：<span class="vote-count-num">' +
      info.vote.total.value +
      "</span></span>" +
      '<span class="vote-tip">最多可选 ' +
      info.vote.votetype.value +
      " 项" +
      (info.vote.voted.value ? "" : "<span>（投票后查看结果）</span>") +
      "</span>" +
      '<div class="vote-options ' +
      (that.maxCount > 1 ? "mulit" : "") +
      '">' +
      options +
      "</div>" +
      (info.vote.voted.value ? "" : '<span class="vote-submit">提交</span>') +
      "</div>";
    ele.innerHTML = html;
    if (info.vote.voted.value) {
      // vote-result-progress-inner-4747
      setTimeout(function () {
        info.vote.items.item.forEach(function (option, index) {
          var dom = ele.querySelector(
            ".vote-result-progress-inner-" + option.i.value
          );
          if (dom) {
            dom.style.width = getWidthPercent(
              option.c.value,
              info.vote.total.value
            );
          }
        });
        resizerPatchfunction();
      }, 200);
    }
  }

  function bindEvent(info) {
    // 选项
    var options = ele.querySelectorAll(".vote-option");
    for (var i = 0; i < options.length; i++) {
      var option = options[i];
      option.onclick = function (e) {
        rm.vibrate();
        var node = e.target;
        if (info.vote.voted.value) {
          return;
        }
        var optionId = parseInt(node.getAttribute("data-id"));
        if (that.mySelect.indexOf(optionId) !== -1) {
          that.mySelect.splice(that.mySelect.indexOf(optionId), 1);
          node.classList.remove("checked");
        } else {
          if (that.mySelect.length >= that.maxCount && that.maxCount > 1) {
            toast("最多可选" + that.maxCount + "项");
          } else if (that.maxCount === 1) {
            that.mySelect = [optionId];
          } else {
            that.mySelect.push(optionId);
          }
        }
        // 更新选择
        for (var j = 0; j < options.length; j++) {
          var thisOption = options[j];
          var id = parseInt(thisOption.getAttribute("data-id"));
          if (that.mySelect.indexOf(id) !== -1) {
            thisOption.classList.add("checked");
          } else {
            thisOption.classList.remove("checked");
          }
        }
      };
    }
    // 提交
    var submit = ele.querySelector(".vote-submit");
    if (submit) {
      submit.onclick = function () {
        if (that.mySelect.length === 0) {
          toast(that.maxCount === 1 ? "请选择一个选项" : "请至少选择一个选项");
          return;
        }
        if (that.mySelect.length > that.maxCount) {
          toast("您最多只能选择" + that.maxCount + "个选项");
          return;
        }
        rm.vibrate();
        doAfterLogin(function () {
          var url = Api(
            "https://dyn.ithome.com/api/vote.asmx/PostVote?userHash={userhash}&voteID={voteid}&items={voteitems}&os={ostype}&device={device}",
            {
              userhash: getUserHash(),
              voteid: info.vote.id.value,
              voteitems: that.mySelect.join(","),
              ostype: myosType,
              device: model,
            }
          );
          rm.request({ url: url }, function (submitResXml) {
            if (submitResXml.statusCode === 200 && submitResXml.data) {
              var submitRes = xml2json(submitResXml.data);
              if (submitRes.string.value) {
                var resultStr = submitRes.string.value;
                if (
                  resultStr.indexOf("投票成功") !== -1 ||
                  resultStr.indexOf("投过票了") !== -1
                ) {
                  info.vote.voted.value = true;
                  if (resultStr.indexOf("投票成功") !== -1) {
                    var resultTotal = parseInt(info.vote.total.value) + 1;
                    info.vote.total.value = resultTotal + "";
                    info.vote.items.item.forEach(function (item, index) {
                      if (
                        that.mySelect.indexOf(parseInt(item.c.value)) !== -1
                      ) {
                        item.c.value = parseInt(item.c.value) + 1 + "";
                      }
                    });
                  }
                  generateVoteHtml(info);
                }
                toast(resultStr);
              } else {
                toast("投票失败，稍后再试");
              }
            }
          });
        }, "登录后才能投票哦~");
      };
    }
  }

  function getWidthPercent(count, total) {
    if (parseInt(total) === 0) {
      return "0%";
    }
    var percent = (parseInt(count) / parseInt(total)) * 100;
    var percentStr = percent.toFixed(2) + "";
    while (
      percentStr.length > 1 &&
      (percentStr[percentStr.length - 1] === "0" ||
        percentStr[percentStr.length - 1] === ".")
    ) {
      percentStr = percentStr.substring(0, percentStr.length - 1);
    }
    return percentStr + "%";
  }
  function getColorIndex(index) {
    return index % 5;
  }
}

function checkTable(node) {
  var tableList = node.querySelectorAll("table");
  hasTable = tableList.length > 0;
  if (hasTable) {
    for (var i = 0; i < tableList.length; i++) {
      var e = tableList[i];
      var p = document.createElement("div");
      p.className = "tableDiv";
      p.innerHTML = e.outerHTML;
      e.parentNode.replaceChild(p, e);
    }
  }
}

function dealWithShareMode() {
  window._shareImgMaxHeight = 10000;
  if (isShareMode) {
    var currentProgress = 0;
    var isIos = rm.getEnv().platform === "iOS";

    // 处理图片
    var imgs = content.querySelectorAll("img");
    if (imgs.length === 0) {
      rm.sendMessage({
        name: "shareProcessProgress",
        progress: 100,
        text1: "长按识别二维码阅读原文",
        text2: "即时科技资讯尽在IT之家",
        maxHeight: window._shareImgMaxHeight,
        showComment: false,
      });
    } else {
      // checkReady();
      for (var index = 0; index < imgs.length; index++) {
        var element = imgs[index];
        // var realSrc = getRealSrc(element);
        var hasOriginal = !isEmpty(getRealSrc(element));
        var realUrlIsSet =
          !hasOriginal || getRealSrc(element) === element.getAttribute("src");
        if (!realUrlIsSet) {
          element.onload = function () {
            this.classList.add("loaded");
          };
          element.onerror = function () {
            this.classList.add("error");
          };
          element.setAttribute("src", getRealSrc(element));
        } else {
          element.classList.add("skip");
        }
      }
      setTimeout(function () {
        checkReady();
        if (isIos && content.clientHeight > window._shareImgMaxHeight) {
          content.style.maxHeight = window._shareImgMaxHeight + "px";
          content.insertAdjacentHTML(
            "beforeend",
            "<div class='share_end'><div class='share_end_musk'></div><div class='share_end_tip'>下载IT之家App查看原文</div></div>"
          );
        }
      }, 80);
      var timer = setInterval(function () {
        checkReady();
      }, 150);
    }

    function checkReady() {
      var allImgs = content.querySelectorAll("img");
      var imgsNotReady = [];
      for (var index = 0; index < allImgs.length; index++) {
        var element = allImgs[index];
        var hasOriginal = !isEmpty(getRealSrc(element));
        var realUrlIsSet =
          !hasOriginal || getRealSrc(element) === element.getAttribute("src");
        var imgLoaded =
          element.classList.contains("loaded") ||
          element.classList.contains("skip") ||
          element.classList.contains("error");
        var complete = realUrlIsSet && imgLoaded;
        if (!complete) {
          imgsNotReady.push(element);
        }
      }

      var progress = parseFloat(
        (allImgs.length === 0
          ? 100
          : (1 - (imgsNotReady.length * 1.0) / allImgs.length) * 100
        ).toFixed(0)
      );
      if (progress !== currentProgress) {
        currentProgress = progress;
        setTimeout(function () {
          rm.sendMessage({
            name: "shareProcessProgress",
            progress: progress,
            text1: "长按识别二维码阅读原文",
            text2: "即时科技资讯尽在IT之家",
            maxHeight: window._shareImgMaxHeight,
            showComment: false,
          });
        }, 100);
      }
      if (progress > 99.999999999) {
        clearInterval(timer);
      }
    }
  }
}

function clickFeedback() {
  setTimeout(function () {
    var model = rm.getSystemInfoSync().systemInfo.model || "";
    if (rm.getEnv().platform === "Android") {
      myosType = "android";
    } else if (model.toLowerCase().indexOf("ipad") !== -1) {
      myosType = "ipad";
    } else {
      myosType = "iphone";
    }
    var url = Api("https://dyn.ithome.com/ithome/hitcount.aspx", {
      newsid: newsId,
      dev: myosType,
    });
    rm.request(
      {
        url: url,
      },
      function (res) {
        console.log("click feedback", url, res);
      }
    );
  }, 50);
}

function loadViewCount(initCount) {
  if (getUserInfo().isc === "true" || getUserInfo().ism === "true") {
    setTimeout(function () {
      var dom = null;
      if (itAccountId > 0) {
        dom = document.querySelectorAll(".viewcount_value")[1];
        if (dom) dom.innerText = initCount + "浏览";
      } else {
        dom = document.querySelectorAll(".viewcount_value")[0];
        if (dom) dom.innerText = initCount;
      }
      var api = Api("https://dyn.ithome.com/json/newscount", {
        userHash: getUserHash(),
        sid: rm.encryptSync({ text: newsId + "" }).data,
      });
      if (dom) {
        rm.request(
          {
            url: api,
          },
          function (res) {
            if (res.data && res.data.content) {
              var count = res.data.content.hitcount || 0;
              if (itAccountId > 0) {
                dom.innerText = count + "浏览";
              } else {
                dom.innerText = count;
              }
              document.querySelector(".viewcount_value").innerText =
                res.data.content.hitcount || 0;
            }
          }
        );
      }
    }, 0);
  }
}

////////////////////////////////////////
///////////                //////////////
//////////       工具      /////////////
//////////                 /////////////
////////////////////////////////////////

function getUserInfo() {
  return rm.getUserInfoSync().userInfo || {};
}

function getUserId() {
  return (rm.getUserInfoSync().userInfo || {}).userid;
}

function isLogin() {
  return getUserId() > 0;
}

function getUserHash() {
  return rm.getUserHashSync().userHash || "";
}

function toast(str) {
  rm.toast({
    data: str,
  });
}

function doAfterLogin(func, fallback) {
  rm.login(function (res) {
    if (res.success) {
      func();
    } else {
      if (typeof fallback === "function") {
        fallback();
      } else if (!isEmpty(tips))
        rm.toast({
          data: tips,
        });
    }
  });
}
function getAvatarAddress(e, t) {
  for (var r = e + ""; r.length < 9; ) r = "0" + r;
  var n = r.substring(0, 3),
    a = r.substring(3, 5),
    i = r.substring(5, 7),
    s = r.substring(7, 9),
    o =
      "https://avatar.ithome.com/avatars/" +
      n +
      "/" +
      a +
      "/" +
      i +
      "/" +
      s +
      "_60.jpg";
  return (
    t &&
      (o =
        "https://my.ruanmei.com/images/upload/avatars/" +
        n +
        "/" +
        a +
        "/" +
        i +
        "/" +
        s +
        "_avatar.jpg"),
    o
  );
}
function getNewsUrl(item) {
  var idStr = item.newsid + "";
  while (idStr.length < 7) {
    idStr = "0" + idStr;
  }
  var url =
    "https://www.ithome.com/" +
    idStr.substring(0, 1) +
    "/" +
    idStr.substring(1, 4) +
    "/" +
    idStr.substring(4) +
    ".htm";
  var slink = "ithome://news?id=" + item.newsid + "&type=news&_newtask=1";
  if (item.live) {
    url = "https://live.ithome.com/item/" + item.newsid + ".htm";
    slink = "ithome://news?id=" + item.newsid + "&type=live&_newtask=1";
  } else if (item.sid) {
    url = item.url;
    slink = "ithome://newstopic?id=" + item.sid + "&_newtask=1";
  }
  if (url.indexOf("http") === -1) {
    url = "https://www.ithome.com" + url;
  }
  return {
    url: url,
    slink: slink,
  };
}
function isClickIn(filter, e) {
  var target = e.target;
  var fireEvent = false;
  while (!fireEvent && !!target && target !== e.currentTarget) {
    if (filter(target)) {
      fireEvent = true;
      break;
    }
    target = target.parentElement || target.parentNode;
  }
  return fireEvent;
}

function isIn(target, filter) {
  var fireEvent = false;
  while (!fireEvent && !!target && target !== document.body) {
    if (filter(target)) {
      fireEvent = true;
      break;
    }
    target = target.parentElement || target.parentNode;
  }
  return fireEvent;
}

function findParent(node, filterFn, includeSelf) {
  if (node && !isBody(node)) {
    node = includeSelf ? node : node.parentNode;
    while (node) {
      if (!filterFn || filterFn(node) || isBody(node)) {
        return filterFn && !filterFn(node) && isBody(node) ? null : node;
      }
      node = node.parentNode;
    }
  }
  return null;
}

function findParentByTagName(node, tagNames, includeSelf, excludeFn) {
  tagNames = listToMap(Array.isArray(tagNames) ? tagNames : [tagNames]);
  return findParent(
    node,
    function (node) {
      return tagNames[node.tagName] && !(excludeFn && excludeFn(node));
    },
    includeSelf
  );
}

function listToMap(list) {
  if (!list) return {};
  list = Array.isArray(list) ? list : list.split(",");
  for (var i = 0, ci, obj = {}; (ci = list[i++]); ) {
    obj[ci.toUpperCase()] = obj[ci] = 1;
  }
  return obj;
}
function uuid() {
  var s = [];
  var hexDigits = "0123456789abcdef";
  for (var i = 0; i < 36; i++) {
    s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
  }
  s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
  s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
  s[8] = s[13] = s[18] = s[23] = "-";

  var uuid = s.join("");
  return uuid;
}
function isBody(node) {
  return node.tagName === "BODY";
}
function isEmpty(e) {
  return void 0 === e || null == e || 0 == e.length;
}
function getDateFromString(e) {
  var t = e;
  return isEmpty(t)
    ? new Date()
    : "number" == typeof t
    ? new Date(t)
    : (-1 != t.indexOf("/Date(")
        ? ((t = t.replace("/Date(", "").replace(")/", "")), (t = parseInt(t)))
        : t.indexOf("T") > 0 &&
          (t.lastIndexOf(".") > 0 && (t = t.substring(0, t.lastIndexOf("."))),
          -1 == t.indexOf("+") && -1 == t.indexOf("Z") && (t += "+08:00")),
      new Date(t));
}
function getAnchorPmark(target) {
  var pMark = "";
  var anchorNode = target;
  var searchTime = 1;
  while (
    anchorNode &&
    anchorNode.tagName !== "P" &&
    anchorNode.tagName !== "H1" &&
    anchorNode.tagName !== "H2" &&
    anchorNode.tagName !== "DIV" &&
    (anchorNode.parentNode || anchorNode.parentElement) &&
    searchTime < 20
  ) {
    searchTime++;
    anchorNode = anchorNode.parentNode || anchorNode.parentElement;
  }
  if (anchorNode && anchorNode.hasAttribute("data-vmark")) {
    pMark = anchorNode.getAttribute("data-vmark");
  } else if (anchorNode && anchorNode.tagName === "H1") {
    pMark = "head";
  }
  return pMark;
}
function getSelectionHtml() {
  var html = "";
  if (typeof window.getSelection != "undefined") {
    var sel = window.getSelection();
    if (sel.rangeCount) {
      var container = document.createElement("div");
      for (var i = 0, len = sel.rangeCount; i < len; ++i) {
        container.appendChild(sel.getRangeAt(i).cloneContents());
      }
      html = container.innerHTML;
    }
    if (sel.anchorNode && (!html || html.length === 0)) {
      html = sel.anchorNode.textContent || sel.anchorNode.nodeValue;
    }
  } else if (typeof document.selection != "undefined") {
    if (document.selection.type == "Text") {
      html = document.selection.createRange().htmlText;
    }
  }
  var container = document.createElement("div");
  container.innerHTML = html;
  var text = container.innerText;
  return {
    html: html,
    text: text,
  };
}
function pad(e, t) {
  for (var r = e.toString().length; r < t; ) (e = "0" + e), r++;
  return e;
}
function Api(url, params) {
  var result = url;
  if (params) {
    Object.keys(params).forEach(function (key) {
      var value = encodeURIComponent(params[key]);
      if (result.indexOf("{" + key.toLowerCase() + "}") !== -1) {
        result = result.replace("{" + key.toLowerCase() + "}", value);
      } else {
        var keyValue = key + "=" + value;
        result += (result.indexOf("?") !== -1 ? "&" : "?") + keyValue;
      }
    });
  }
  return result;
}
function highlightKeyWords(node, keywords) {
  var list = keywords.slice(0);
  list.forEach(function (item) {
    var patterns = hanldeKeyword([item.key]);
    highlightKeyword(node, patterns[0], item);
  });
}
function hanldeKeyword(keywords) {
  var wordMatchString = "";
  var words = keywords.slice(0);
  words.forEach(function (item) {
    var transformString = item.replace(/[.[*?+^$|()/]|\]|\\/g, "\\$&");
    wordMatchString += "|(" + transformString + ")";
  });
  wordMatchString = wordMatchString.substring(1);
  // 用于再次高亮与关闭的关键字作为一个整体的匹配正则
  var wholePattern = new RegExp("^" + wordMatchString + "$");
  // 用于第一次高亮的关键字匹配正则
  var pattern = new RegExp(wordMatchString);
  return [pattern, wholePattern];
}
function highlightKeyword(node, pattern, errorInfo, index) {
  var exposeCount = 0;
  if (node.nodeType === Node.TEXT_NODE) {
    var matchResult = node.data.match(pattern);
    if (matchResult) {
      var highlightEl = document.createElement("span");
      highlightEl.dataset.highlight = "quote";
      index == null || (highlightEl.dataset.highlightIndex = index + "");
      var initOffset = matchResult.index;
      var matchNode = node.splitText(
        errorInfo.singleindex === -1
          ? initOffset
          : initOffset + errorInfo.singleindex
      );
      matchNode.splitText(
        errorInfo.singleindex === -1 ? matchResult[0].length : 1
      );

      var highlightTextNode = document.createTextNode(matchNode.data);
      highlightEl.appendChild(highlightTextNode);
      matchNode.parentNode.replaceChild(highlightEl, matchNode);
      exposeCount++;
    }
  } else if (
    node.nodeType === 1 &&
    !/script|style/.test(node.tagName.toLowerCase())
  ) {
    if (node.dataset.highlight === "quote") {
      if (index == null) {
        return;
      }
      if (node.dataset.highlightIndex === index + "") {
        return;
      }
    }
    var childNodes = node.childNodes;
    for (var i = 0; i < childNodes.length; i++) {
      highlightKeyword(childNodes[i], pattern, errorInfo, index);
    }
  }
  return exposeCount;
}
function normalizeNode(node) {
  var parentNode = node.parentNode;
  var childNodes = node.childNodes;
  var childNodesLen = childNodes.length;
  var nextSibling = node.nextSibling;
  if (parentNode) {
    for (var k = 0; k < childNodesLen; k++) {
      parentNode.insertBefore(childNodes[0], nextSibling);
    }
    var flagNode = document.createTextNode("");
    parentNode.replaceChild(flagNode, node);
    parentNode.normalize();
  }
}
function getBilibiliUrlInfo(u) {
  var url = u;
  if (!isEmpty(url) && url.indexOf("bilibili") !== -1) {
    // 视频
    -1 !== url.indexOf("?") && (url = url.substring(0, url.indexOf("?")));
    -1 !== url.indexOf("#") && (url = url.substring(0, url.indexOf("#")));
    if (url.substring(url.length - 1) === "/") {
      url = url.substring(0, url.length - 1);
    }

    var bilibiliAvReg = /bilibili.com.+av(\d+)/i;
    var matchResult = url.match(bilibiliAvReg);
    var bilibiliBvReg = /bilibili.com.+BV(.+)/i;
    var matchBvResult = url.match(bilibiliBvReg);
    var bilibiliLiveReg = /live.bilibili.co.+\/(\d+)/;
    var matchLiveResult = url.match(bilibiliLiveReg);
    var accountReg = /space.bilibili.com\/(\d+)/;
    var matchAccountResult = url.match(accountReg);

    if (matchResult && matchResult.length == 2) {
      var avNum = matchResult[1];
      return { avid: avNum, scheme: "bilibili://video/" + avNum };
    } else if (matchBvResult && matchBvResult.length == 2) {
      var bvNum = matchBvResult[1];
      if (bvNum.toLowerCase().indexOf("bv") !== 0) {
        //修正BV号
        bvNum = "bv" + bvNum;
      }
      return { bvid: bvNum, scheme: "bilibili://video/" + bvNum };
    } else if (matchLiveResult && matchLiveResult.length == 2) {
      var roomId = matchLiveResult[1];
      return { liveid: roomId, scheme: "bilibili://live/" + roomId };
    } else if (matchAccountResult && matchAccountResult.length == 2) {
      var accountId = matchAccountResult[1];
      return { spaceid: accountId, scheme: "bilibili://space/" + accountId };
    }
  }
  return {};
}
function __parseUrl(n) {
  var e = n.split("://"),
    i = e[0],
    s = e[1];
  -1 != s.indexOf("/") && (s = s.split("/")[0]),
    -1 !== s.indexOf("?") && (s = s.substring(0, s.indexOf("?"))),
    -1 !== s.indexOf("#") && (s = s.substring(0, s.indexOf("#")));
  var r = {},
    t = "",
    d = "",
    f = n.substring(n.indexOf("?") + 1, n.length).split("&");
  for (var x in f) {
    var O = f[x];
    O.indexOf("=") > 0 &&
      ((t = O.substring(0, O.indexOf("="))),
      (d = O.substring(O.indexOf("=") + 1)),
      -1 !== d.indexOf("#") && (d = d.substring(0, d.indexOf("#"))),
      (r[t] = decodeURIComponent(d)));
  }
  return { scheme: i.toLowerCase(), host: s.toLowerCase(), params: r };
}
function setTimeoutOnce(timerKey, task, delay, maxInterval) {
  if (
    Math.abs(
      new Date().getTime() - ((window["lastExeTimeFor"] || {})[timerKey] || 0)
    ) > (maxInterval || delay)
  ) {
    if (!window["lastExeTimeFor"]) {
      window["lastExeTimeFor"] = {};
    }
    window["lastExeTimeFor"][timerKey] = new Date().getTime();
    task();
  }
  clearTimeout(window[timerKey] || 0);
  window[timerKey] = setTimeout(function () {
    if (!window["lastExeTimeFor"]) {
      window["lastExeTimeFor"] = {};
    }
    window["lastExeTimeFor"][timerKey] = new Date().getTime();
    task();
  }, delay);
}

function clearTimeoutOnce(timerKey) {
  clearTimeout(window[timerKey] || 0);
}
function getRealSrc(element) {
  if (!isEmpty(element.getAttribute("data-orignal"))) {
    return element.getAttribute("data-orignal");
  }
  if (!isEmpty(element.getAttribute("src"))) {
    return element.getAttribute("src");
  }
  return null;
}

function forEachNode(container, query, callback) {
  var all = container.querySelectorAll(query);
  for (var i = 0; i < all.length; i++) {
    var dom = all[i];
    callback(dom);
  }
}
function _checkSwipeGesture(touchYDP) {
  var allIframeElement = content.getElementsByTagName("iframe");
  var allPreElement = content.getElementsByTagName("pre");
  var allVideoElement = content.getElementsByTagName("video");
  var allTableDiv = content.getElementsByClassName("tableDiv");
  var allPreBars = content.getElementsByClassName("pre-bar");
  var canSwipe =
    checkIfNotInElements(allIframeElement, touchYDP) && //不在iframe内
    checkIfNotInElements(allPreElement, touchYDP) && //不在pre代码块内
    checkIfNotInElements(allVideoElement, touchYDP) && //不在video内
    checkIfNotInElements(allTableDiv, touchYDP) && //不在tableDiv内
    checkIfNotInElements(allPreBars, touchYDP); //不在Pre bar内
  return canSwipe;
}

function checkIfInElement(anchor, touchYDP) {
  var rect = anchor.getBoundingClientRect();
  var top = rect.top;
  var bottom = rect.bottom;
  return touchYDP >= top - 6 && touchYDP <= bottom + 6;
}

function checkIfNotInElements(elements, touchYDP) {
  var alenght = elements.length;
  var notIn = true;
  if (alenght > 0) {
    for (var i = 0; i < alenght; i++) {
      var anchor = elements[i];
      if (checkIfInElement(anchor, touchYDP)) {
        notIn = false;
      }
    }
  }
  return notIn;
}
function getSwitchByPosition(flags, position){
  if (position < 0) {
      return false;
  }
  // eslint-disable-next-line no-bitwise
  return (flags & (Math.pow(2, position))) > 0;
}