var filePath = document.getElementById("filePath");
var files = [];
var fileCurrentUpload = null;
var filesWaitUpLoad = [];
var filesUploaded = [];
var fileNameCurrentUse = "";

function deleteFontFile(index){
    $.ajax({
        url: "http://"+ window.location.host + "/ajax/delete/" + files[index].fileName,
        type: "POST",
        timeout:8000,
        success: function(data) {
            getDeviceFontInfo();
        },
        error:function(jqXHR,textStatus,errorThrown){

        }
    });
 }
 function resetToDefault(){
      $.ajax({
          url: "http://"+ window.location.host + "/ajax/resetdefault/",
          type: "POST",
          timeout:8000,
          success: function(data) {
              getDeviceFontInfo();
              if(data != "success")
                 alert(data);
          },
          error:function(jqXHR,textStatus,errorThrown){

          }
      });
 }
 function applyFont(index){
     $.ajax({
         url: "http://"+ window.location.host + "/ajax/applyfont/" + files[index].fileName,
         type: "POST",
         timeout:8000,
         success: function(data) {
             getDeviceFontInfo();
             if(data != "success")
                alert(data);
         },
         error:function(jqXHR,textStatus,errorThrown){

         }
     });
  }
function clearFontFolder(){
    $.ajax({
        url: "http://"+ window.location.host + "/ajax/deleteall",
        type: "POST",
        timeout:8000,
        success: function(data) {
            getDeviceFontInfo();
        },
        error:function(jqXHR,textStatus,errorThrown){

        }
    });
 }
function init(){
    document.getElementById("filePath").addEventListener("change", fileSelected, false);
    getDeviceFontInfo();
    $("#reset_default").click(function(){
      resetToDefault();
    });
    $("#refresh_btn").click(function(){
      getDeviceFontInfo();
    });
    $("#clear_btn").click(function(){
        if (confirm("您确认要删除所有已上传的字体吗？")){
            clearFontFolder();
        }
    });
}

function fileSelected(event) {
    event.stopPropagation();
    event.preventDefault();
    var filePath = document.getElementById("filePath");
    var filelist = filePath.files;
    if (filelist.length == 0) {
        alert("没有选择到文件");
        return;
    }
    var file = filelist[0];
    uploadFile(file, "");
}

function clearCurrent(){
    fileCurrentUpload = null;
    $("#filePath").val("");
}

function uploadFile(file, status) {
    fileCurrentUpload = new Object();
    fileCurrentUpload.fileName = file.name;
    fileCurrentUpload.fontSize = file.size;
    fileCurrentUpload.state = "正在上传";
    displayList();

    var xhr = new XMLHttpRequest();
    var urlCodeName = encodeURI(file.name);
    xhr.open('POST', "/upload/" + urlCodeName);
    xhr.onload = function() {
        clearCurrent();
        getDeviceFontInfo();
    };
    xhr.onerror = function() {
        $("#currentUpload .progressbar").width(0);
        $("#currentUpload .fontState").html("上传失败");
        clearCurrent();
    };
    xhr.upload.onprogress = function(event) {
        $("#currentUpload .progressbar").width(event.loaded*100/file.size+"%");
    };
    xhr.upload.onloadstart = function(event) {
    };
    var formData = new FormData();
    formData.append('myfile', file);

    xhr.send(formData);
}

function getDisplayFontSize(size){
    var sizeMB = Math.round((size/(1024*1024))*100)/100;
    return sizeMB + " MB";
}

function getDeviceFontInfo(){
    $.ajax({
        url: "http://"+ window.location.host + "/ajax/getInfo",
        type: "GET",
        timeout:8000,
        success: function(data) {
            if(data){
                var info = eval ("(" + data + ")");
                $("#contentHeaderTitle").html("我的 " + info.deviceName);
                fileNameCurrentUse = info.currentFontFileName;
                filesUploaded = [];
                if(info.fontInfos != null && info.fontInfos.length > 0){
                    for(var i = 0; i < info.fontInfos.length; i++){
                        var fileInfo = new Object();
                        fileInfo.fileName = info.fontInfos[i].fileName;
                        fileInfo.fontName = info.fontInfos[i].fontName;
                        fileInfo.fontSize = info.fontInfos[i].fontSize;
                        fileInfo.state = "已上传";
                        filesUploaded.push(fileInfo);
                    }
                }
                displayList();
            }
        },
        error:function(jqXHR,textStatus,errorThrown){
            $("#contentHeaderTitle").html("连接失败");
        }
    });
}

function displayList(){
    files = [];
    if(fileCurrentUpload != null){
        files.push(fileCurrentUpload);
    }
    if(filesWaitUpLoad.length > 0){
        for(var i = 0; i < filesWaitUpLoad.length; i++){
            files.push(filesWaitUpLoad[i]);
        }
    }
    if(filesUploaded.length > 0){
        for(var i = 0; i < filesUploaded.length; i++){
            files.push(filesUploaded[i]);
        }
    }
    $("#fontList").html("");
    if(files.length > 0){
        $("#uploadTip").hide();
        for(var i = 0; i < files.length; i++){
            var fileInfo = files[i];
            var name = fileInfo.fontName ? fileInfo.fontName + " <span class=\"saveFileName\">（<a href=\"http://" + window.location.host + "/download/" + fileInfo.fileName + "\"  target=\"_blank\" download=\""
            + fileInfo.fontName + "-" + fileInfo.fileName + "\">"
            + fileInfo.fileName + "</a>）</span>" : fileInfo.fileName;
            var isCurrentUse = fileInfo.fileName == fileNameCurrentUse;
            var applyBtn = i >= filesWaitUpLoad.length ? "<span class=\"applyBtn\"" + (isCurrentUse ? " id=\"currentUse\">使用中" : " onclick=\"applyFont("+ i +")\" >应　用") + "</span>" : "";
            var state = fileInfo.state ? fileInfo.state : "未知";
            var currentId = fileInfo.state == "正在上传" ? " id=\"currentUpload\"" : "";
            var html = "<li" + currentId + "><span class=\"progressbar\"></span><span class=\"fontName\">"
                    + name + "</span>" + applyBtn + "<span class=\"fontState\">"
                    + state + "</span><span onclick=\"deleteFontFile("+ i +")\" class=\"fontDelBtn\"></span><span class=\"fontSize\">"
                    + getDisplayFontSize(fileInfo.fontSize) + "</span></li>";
            $("#fontList").append(html);
        }
    }else{
        $("#uploadTip").show();
    }
}
(function() {init();})();